/* --------------------------------------------------------------------------  
 *
 * namespace BasicTypes
 *   typedefs for frequently occurring numeric/non-numeric types
 *
 * required headers
 *   see include header file BasicTypes
 *
 * --------------------------------------------------------------------------
 * $Id$
 * ---------------------------------------------------------------------------- */

#ifndef __BasicTypes_H__
#define __BasicTypes_H__

cpp_using_namespace( std );
cpp_using_namespace( FortranTypes );

cpp_gnamespace_begin( BasicTypes )

  // ------------------------------------------------------ floating-point types
  // ---------------------------------------------------------------------------

  typedef dReal          fpType;

  typedef varray<fpType> fpVector;
  typedef matrix<fpType> fpMatrix;

  // ------------------------------------------------------------- integer types
  // ---------------------------------------------------------------------------

  typedef varray<integer> intVector;
  typedef varray<size_t>  uintVector;

  // ------------------------------------------------------------- miscellaneous
  // ---------------------------------------------------------------------------

  typedef vector<bool> MaskType;
                       //
                       // useful for iterating over permutations of a binary key

cpp_gnamespace_end

#endif /* __BasicTypes_H__ */
