/* --------------------------------------------------------------------------
 *
 * class polynomial
 *   implementation
 *
 * --------------------------------------------------------------------------
 * $Id$
 * ---------------------------------------------------------------------------- */

#include <basic/polynomial>

// -----------------------------------------------------------------------------
// ---------------------------------------------------------------- constructors

polynomial::polynomial( )
 : my_coeff( fpVector( 0.0, 1 ) )
 {
 }

polynomial::polynomial( size_t degree )
 : my_coeff( fpVector( 0.0, degree + 1 ) )
 {
 }

polynomial::polynomial( size_t degree, const fpType* coeff )
 : my_coeff( fpVector( coeff, degree + 1 ) )
 {
 }

polynomial::polynomial( const fpVector& coeff )
 : my_coeff( coeff )
 {
 }

polynomial::polynomial( const polynomial& another )
 : my_coeff( another.my_coeff )
 {
 }

// -----------------------------------------------------------------------------
// ---------------------------------------------------------------- reinitialize

void
polynomial::reinitialize( size_t degree )
 {
  my_coeff.resize( degree + 1, 0.0 );
 }

void
polynomial::reinitialize( size_t degree, const fpType* coeff )
 {
  my_coeff.resize( degree + 1, 0.0 );
  for ( size_t i = 0; i <= degree; i++ ) my_coeff[i] = coeff[i];
 }

void
polynomial::reinitialize( const fpVector& coeff )
 {
  my_coeff.resize( coeff.size( ), 0.0 );
  my_coeff = coeff;
 }

void
polynomial::reinitialize( const polynomial& another )
 {
  my_coeff.resize( another.my_coeff.size( ), 0.0 );
  my_coeff = another.my_coeff;
 }
