/* --------------------------------------------------------------------------
 *
 * class BasicBell
 *   implementation
 *
 * --------------------------------------------------------------------------
 * $Id$
 * ---------------------------------------------------------------------------- */

#include <brain.model/BasicBell>

BasicBell::~BasicBell( )
 {
 }

BasicBell::BasicBell( const BasicBell& another )
 : my_name( another.my_name ),
   my_description( another.my_description ),
   my_pnames( another.my_pnames ),
   my_pdescriptions( another.my_pdescriptions ),
   my_boundTypes( another.my_boundTypes ),
   my_lowerBounds( another.my_lowerBounds ),
   my_upperBounds( another.my_upperBounds )
 {
 }

BasicBell&
BasicBell::operator=( const BasicBell& rhs )
 {
  if ( &rhs == this ) return *this;

  my_name          = rhs.my_name;
  my_description   = rhs.my_description;
  my_pnames        = rhs.my_pnames;
  my_pdescriptions = rhs.my_pdescriptions;
  my_boundTypes    = rhs.my_boundTypes;
  my_lowerBounds   = rhs.my_lowerBounds;
  my_upperBounds   = rhs.my_upperBounds;

  return *this;
 }

BasicBell::BasicBell( size_t numParams, const string& name, const string& description )
 : my_name( name ),
   my_description( description ),
   my_pnames( numParams, "anonymous" ),
   my_pdescriptions( numParams, "no description available" ),
   my_boundTypes( numParams, "none" ),
   my_lowerBounds( numParams, -DBL_MAX ),
   my_upperBounds( numParams, +DBL_MAX )
 {
 }

void
BasicBell::setParamInfo(       size_t  paramIndex,
                         const string& pname,
                         const string& pdescription,
                         const string& boundType,
                               fpType  lowerBound,
                               fpType  upperBound )
 {
  if ( ( paramIndex >= 0 ) && ( paramIndex < my_pnames.size( ) ) )
   {
    my_pnames[paramIndex]        = pname;
    my_pdescriptions[paramIndex] = pdescription;

    if ( boundType == "none" )
     {
      my_boundTypes[paramIndex]  = "none";
      my_lowerBounds[paramIndex] = -DBL_MAX;
      my_upperBounds[paramIndex] = +DBL_MAX;
     }
    else if ( boundType == "lower" )
     {
      my_boundTypes[paramIndex]  = "lower";
      my_lowerBounds[paramIndex] = lowerBound;
      my_upperBounds[paramIndex] = +DBL_MAX;
     }
    else if ( boundType == "upper" )
     {
      my_boundTypes[paramIndex]  = "upper";
      my_lowerBounds[paramIndex] = -DBL_MAX;
      my_upperBounds[paramIndex] = upperBound;
     }
    else if ( boundType == "both" )
     {
      my_boundTypes[paramIndex]  = "both";
      my_lowerBounds[paramIndex] = min( lowerBound, upperBound );
      my_upperBounds[paramIndex] = max( lowerBound, upperBound );
     }
    else
     {
      my_boundTypes[paramIndex]  = "none";
      my_lowerBounds[paramIndex] = -DBL_MAX;
      my_upperBounds[paramIndex] = +DBL_MAX;
     }
   }
 }

string
BasicBell::my_null = "";
