/* ----------------------------------------------------------------------------
 *
 * namespace ParamBlkNames
 *   global directory of standard parameter block names
 *
 * required headers
 *   see include header file ParamBlkNames
 *
 * ----------------------------------------------------------------------------
 * $Id$
 * ---------------------------------------------------------------------------- */

#ifndef __ParamBlkNames_H__
#define __ParamBlkNames_H__

cpp_using_namespace( std );
cpp_using_namespace( BasicTypes );

cpp_namespace_begin( ParamBlkNames )
 cpp_namespace_decl const string drift    = "drift";
 cpp_namespace_decl const string noise    = "noise";
 cpp_namespace_decl const string ar       = "ar";
 cpp_namespace_decl const string response = "response";
 cpp_namespace_decl const string shape    = "shape";

 string
 paramDescr( const ParameterManager<fpType>& parManager );

 string
 responseDescr( const ParameterManager<fpType>& parManager, const acProfile& activation );

 string
 shapeDescr( const ParameterManager<fpType>& parManager, const acProfile& activation );
cpp_namespace_end

#endif /* __ParamBlkNames_H__ */
