#!/bin/tcsh -f

# ---------------------------------------------------------------------------
#
# csh script check.feature.csh
#
# description
#   script to check if a standard C++ feature is supported by a compiler.
#
# usage
#   usage: check.feature.csh test_file compilation_command
#
# notes
#   0. return codes
#        0 supported
#        1 unsupported
#        2 test_file does not exist or of zero length
#   1. depends on the compiler returning a 0 return code for success
#
# ---------------------------------------------------------------------------
# $Id$
# ---------------------------------------------------------------------------

# test file for c++ feature
#
 set testfile = ${argv[1]}

# compilation command
#
 set compile = ( ${argv[2-]} )

# check feature
#
 if ( -s ${testfile} ) then
   echo "\n${0:t}: feature test file ${testfile}\n"

  ${compile} ${testfile}

  if ( ${status} == 0 ) then
   set exitstatus = 0
  else
   set exitstatus = 1
  endif
 else
  set exitstatus = 2
 endif

 exit ${exitstatus}
