// Meyers Item 2, p.12

#include<typeinfo>

struct point { int x, y; };

class Shape { virtual void draw( const point& origin ) = 0; };

class Circle   : public Shape { void draw( const point& origin ) { } };
class Triangle : public Shape { void draw( const point& origin ) { } };
class Square   : public Shape { void draw( const point& origin ) { } };

void update( Circle *psw ) { }
void updateViaRef( Circle& rsw ) { }

// Stroustrup 15.4.5, page 417: misuse example

void rotate( const Shape& r )
 {
       if ( typeid( r ) == typeid( Circle   ) ) { }
  else if ( typeid( r ) == typeid( Triangle ) ) { }
  else if ( typeid( r ) == typeid( Square   ) ) { }
 }

int main ( )
 {
  Shape* pw = 0;

  update( dynamic_cast<Circle*>( pw ) );
  updateViaRef( dynamic_cast<Circle&>( *pw ) );

  return 0;
 }
