#!/bin/tcsh -f

# ---------------------------------------------------------------------------
#
# csh script create.stubs.csh
#
# ---------------------------------------------------------------------------
# $Id$
# ---------------------------------------------------------------------------

# stubs directory path
#
 if ( ${#argv} == 0 ) then
   set stubdir = .
 else
   set stubdir = ${argv[1]}
 endif

# standard c++ headers
#
 set cppheaders = ( algorithm bitset complex deque exception )
 set cppheaders = ( ${cppheaders} fstream functional )
 set cppheaders = ( ${cppheaders} iomanip ios iosfwd iostream istream iterator )
 set cppheaders = ( ${cppheaders} list map memory new numeric )
 set cppheaders = ( ${cppheaders} ostream queue )
 set cppheaders = ( ${cppheaders} set sstream stack stdexcept streambuf )
 set cppheaders = ( ${cppheaders} typeinfo utility valarray vector )

# c++ headers limits, locale and string are excluded from the stubs
# list because of the ambiguity about corresponding c .h headers
#
# set cppheaders = ( ${cppheaders} limits locale string )

# c++ headers for c standard library (without prefix "c")
#
 set cheaders = ( assert ctype errno float iso646 limits locale math )
 set cheaders = ( ${cheaders} setjmp signal stdarg stddef )
 set cheaders = ( ${cheaders} stdio stdlib string )
 set cheaders = ( ${cheaders} time wchar wctype )

# create c header stubs
#
 foreach header ( ${cheaders} )
  cat > ${stubdir}/c${header} << @EOF
#ifndef __cppheader_c${header}__
#define __cppheader_c${header}__

/* stub for standard c++ header with nonstandard filename */

#undef cpp_missing_header_c${header}

#include <${header}.h>

#endif /* __cppheader_c${header}__ */
@EOF
 end

# create c++ header stubs
#
 foreach header ( ${cppheaders} )
  cat > ${stubdir}/${header} << @EOF
#ifndef __cppheader_${header}__
#define __cppheader_${header}__

/* stub for standard c++ header with nonstandard filename */

#undef cpp_missing_header_${header}

#include <${header}.h>

#endif /* __cppheader_${header}__ */
@EOF
 end
