/* --------------------------------------------------------------------------
 *
 * namespace cpplbfgs
 *   C++ prototypes for the fortran BFGS/quasi-Newton minimizer L-BFGS
 *   ftp://ece.nwu.edu/pub/lbfgs/lbfgs_bcm
 *
 * required headers
 *   see include header file cpplbfgs
 *
 * --------------------------------------------------------------------------
 * $Id$
 * ---------------------------------------------------------------------------- */

#ifndef __cpplbfgs_H__
#define __cpplbfgs_H__

cpp_using_namespace( BasicTypes );

cpp_gnamespace_begin( cpplbfgs )

  extern "C"
   {
    void
    setulb( const integer& n, const integer& m,
            dReal& x,
            const dReal& l, const dReal& u, const integer& nbd,
            dReal& f, dReal& g,
            const dReal& factr, const dReal& pgtol,
            dReal& wa, integer& iwa,
            char& task, integer& iprint, char& csave,
            logical& lsave, integer& isave, dReal& dsave, dReal& epsmch );

    void
    projgr( const integer& n,
            const dReal& l, const dReal& u, const integer& nbd,
            const dReal& x, const dReal& g,
            dReal& sbgnrm );
   }                                                         /* extern "C" {} */

cpp_gnamespace_end

#endif /* __cpplbfgs_H__ */
