/* --------------------------------------------------------------------------
 *
 * class BasicObjFn
 *   implementation
 *
 * --------------------------------------------------------------------------
 * $Id$
 * ---------------------------------------------------------------------------- */

#include <objective.functions/BasicObjFn>

BasicObjFn::~BasicObjFn( )
 {
 }

BasicObjFn::BasicObjFn( )
 : my_paramBufSize( 0 ),
   my_sign( 1.0 ),
   my_name( "some objective function" )
 {
 }

BasicObjFn::BasicObjFn( const BasicObjFn& another )
 : my_paramBufSize( another.my_paramBufSize ),
   my_sign( another.my_sign ),
   my_name( another.my_name )
 {
 }

BasicObjFn&
BasicObjFn::operator=( const BasicObjFn& rhs )
 {
  if ( this == &rhs ) return *this;

  my_paramBufSize = rhs.my_paramBufSize;
  my_sign         = rhs.my_sign;
  my_name         = rhs.my_name;

  return *this;
 }

BasicObjFn::BasicObjFn( int paramBufSize, fpType sign, const string& name )
 : my_paramBufSize( paramBufSize ),
   my_sign( sign ),
   my_name( name )
 {
 }

void
BasicObjFn::setParamBufSize( int paramBufSize )
 {
  my_paramBufSize = paramBufSize;
 }

void
BasicObjFn::setSign( fpType sign )
 {
  my_sign = sign;
 }

void
BasicObjFn::setName( const string& name )
 {
  my_name = name;
 }

void
BasicObjFn::reinitialize( int paramBufSize, fpType sign, const string& name )
 {
  my_paramBufSize = paramBufSize;
  my_sign         = sign;
  my_name         = name;
 }
