/* --------------------------------------------------------------------------
 *
 * class ObjFnManager
 *   implementation
 *
 * --------------------------------------------------------------------------
 * $Id$
 * ---------------------------------------------------------------------------- */

#include <objective.functions/ObjFnManager>

ObjFnManager::ObjFnManager( )
 : BasicObjFn( ),
   my_termList( )
 {
  BasicObjFn::setName( "objective function/additive terms" );
 }

ObjFnManager::ObjFnManager( const ObjFnManager& another )
 : BasicObjFn( another.paramBufSize( ), another.sign( ), another.name( ) ),
   my_termList( another.my_termList )
 {
 }

ObjFnManager&
ObjFnManager::operator=( const ObjFnManager& rhs )
 {
  if ( this == &rhs ) return *this;

  BasicObjFn::setParamBufSize( rhs.paramBufSize( ) );
  BasicObjFn::setSign( rhs.sign( ) );
  BasicObjFn::setName( rhs.name( ) );

  my_termList = rhs.my_termList;

  return *this;
 }

ObjFnManager::ObjFnManager(       int     paramBufSize,
                                  fpType  sign,
                            const string& name )
 : BasicObjFn( paramBufSize, sign, name ),
   my_termList( ObjFnList( ) )
 {
 }

void
ObjFnManager::reinitialize(       int     paramBufSize,
                                  fpType  sign,
                            const string& name )
 {
  BasicObjFn::reinitialize( paramBufSize, sign, name );
  my_termList.clear( );
 }
