/* --------------------------------------------------------------------------
 *
 * header predicates
 *   useful predicates
 *
 * required headers
 *   see include header file predicates
 *
 * --------------------------------------------------------------------------
 * $Id$
 * ---------------------------------------------------------------------------- */

#ifndef __predicates_H__
#define __predicates_H__

template<class P>
struct nameIs : public predicate< nameIs<P>, const P* >
 {
  explicit nameIs( const string& name ) : my_name( name ) { }

  bool
  operator()( const P* p ) const
   {
    return ( p ? ( p->name( ) == my_name ) : false );
   }

  private:
   const string& my_name;
 };

template<class P>
struct nameHas : public predicate< nameHas<P>, const P* >
 {
  public:
   explicit nameHas( const string& name ) : my_name( name ) { }

   bool
   operator()( const P* p ) const
    {
     return ( p ? ( p->name( ).find( my_name ) != string::npos ) : false );
    }

  private:
   const string& my_name;
 };

#endif /* __predicates_H__ */
