#!/bin/tcsh -f

# ---------------------------------------------------------------------------
#
# report machine endianness
#
# command line arguments
#  any command line argument changes the output mode to numeric.
#
# output modes
#  string: "big-endian", "little-endian", or "unknown" on error
#  numeric: 0 for big-endian, 1 for little-endian, -1 for unknown
#
# ---------------------------------------------------------------------------
# $Id$
# ---------------------------------------------------------------------------

 if ( ${#argv} > 0 ) set numeric

 switch ( `perl -le 'printf qq(%s), pack( qq(s2), 1, 2 )' | od -An -tu1 | awk '{print $1$2$3$4}'` )
  case "0102":
   if ( ${?numeric} ) then
    echo 0
    exit 0
   else
    echo big-endian
    exit 0
   endif
  case "1020":
   if ( ${?numeric} ) then
    echo 1
    exit 0
   else
    echo little-endian
    exit 0
   endif
  default:
   if ( ${?numeric} ) then
    echo -1
    exit 1
   else
    echo unknown
    exit 1
   endif
 endsw
