#!/bin/tcsh -f

# ---------------------------------------------------------------------------
#
# try -help for details
#
# ---------------------------------------------------------------------------
# $Id$
# ---------------------------------------------------------------------------

# defaults
#
 set myname = ${0:t}

# verbosity
#
 set verbmax   = 1
 set verbosity = 0

# command line args
#
 if ( ${#argv} == 0 ) set argv = -help

 while ( ${#argv} > 0 )
  switch ( ${argv[1]} )
   case "-h":
   case "-help":
    echo ${myname}
    echo ' Test if chunk with given name exists in a .mri file (echo name if it does).'
    echo ''
    echo 'Command line'
    echo ' [-h|-help]'
    echo ' [-q|-quiet] [-v|-verbosity level] [-V|-verbose]'
    echo ''
    echo ' -c|-chunk chunk'
    echo ' file[.mri]'
    echo ''
    echo 'Termination status codes'
    echo ' 0: normal termination'
    echo ' 1: abnormal termination/absent chunk'
    echo ' 2: unspecified chunk name'
    echo ' >2: abnormal termination'
    echo ''
    echo 'Required utilities/scripts'
    echo ' errmsg.csh mri.list.txt.csh'
#   echo ''
#   echo 'Defaults'
#   echo " verbosity: ${verbosity} (maximum ${verbmax})"
#   echo " temporary files prefix: ${tmp}"
    exit 0;

   case "-q":
   case "-quiet":
    set verbosity = 0; shift; breaksw;

   case "-v":
   case "-verbosity":
    set verbosity = ${argv[2]}; shift; shift; breaksw;

   case "-V":
   case "-verbose":
    set verbosity = ${verbmax}; shift; breaksw;

   case "-c":
   case "-chunk":
    set chunk = ${argv[2]}; shift; shift; breaksw;

   default:
    set infile = "${argv[1]}"; shift; breaksw;
  endsw
 end

 if ( !( ${?chunk} ) ) then
  errmsg.csh 1 ${myname} 2 "unspecified chunk name" 1 ""
  exit ${status}
 endif

 mri.list.txt.csh -verbosity ${verbosity} ${infile} | grep '\= \[chunk\]$' | awk -F= '{gsub("^[ \t]*","",$1);gsub("[ \t]*$","",$1);print $1}' | grep '^'${chunk}'$'
