#!/bin/tcsh -f

# ---------------------------------------------------------------------------
#
# try -help for details
#
# ---------------------------------------------------------------------------
# $Id$
# ---------------------------------------------------------------------------

# defaults
#
 set myname = ${0:t}

# verbosity
#
 set verbmax   = 1
 set verbosity = 0

# command line args
#
 if ( ${#argv} == 0 ) set argv = -help

 while ( ${#argv} > 0 )
  switch ( ${argv[1]} )
   case "-h":
   case "-help":
    echo ${myname}
    echo ' List entire non-binary portion of a .mri file.'
    echo ''
    echo 'Command line'
    echo ' [-h|-help]'
    echo ' [-q|-quiet] [-v|-verbosity level] [-V|-verbose]'
    echo ''
    echo ' file[.mri]'
    echo ''
    echo 'Termination status codes'
    echo ' 0: normal termination'
    echo ' 1: abnormal termination, except'
    echo ' 2: nonexistent .mri file'
    echo ''
    echo 'Required utilities/scripts'
    echo ' errmsg.csh'
#   echo ''
#   echo 'Defaults'
#   echo " verbosity: ${verbosity} (maximum ${verbmax})"
#   echo " temporary files prefix: ${tmp}"
    exit 0;

   case "-q":
   case "-quiet":
    set verbosity = 0; shift; breaksw;

   case "-v":
   case "-verbosity":
    set verbosity = ${argv[2]}; shift; shift; breaksw;

   case "-V":
   case "-verbose":
    set verbosity = ${verbmax}; shift; breaksw;

   default:
    set infile = `echo ${argv[1]} | sed 's/\.mri$//'`; shift; breaksw;
  endsw
 end

 if ( !( -f ${infile}.mri ) ) then
  errmsg.csh 1 ${myname} 2 "nonexistent ${infile}.mri" 1 ""
  exit ${status}
 endif

# ATTN gnu grep needs this extra option -a for treating binary files as text.
#
 set linecount = `grep -an '' ${infile}.mri | head -1 | awk -F: '{print $1-1}'`
 if ( "${linecount}" == '' ) set linecount = `wc -l ${infile}.mri | awk '{print $1}'`

 head -${linecount} ${infile}.mri | sed -e 's/^[ 	]*//' -e 's/[ 	]*$//' | grep -v '^$' | awk '{for(i=1;i<NF;i++)printf "%s ", $i; printf "%s\n", $NF}'
