#!/bin/tcsh -f

# ---------------------------------------------------------------------------
#
# try -help for details
#
# ---------------------------------------------------------------------------
# $Id$
# ---------------------------------------------------------------------------

# command line args
#
 if ( ${#argv} == 0 ) set argv = -help

 if ( "${argv}" == '-help' ) then
  echo `basename ${0}`
  echo ' Wrapper script for fiasco utility mri_permute that bypasses'
  echo ' a case that may cause  mri_permute  to crash: memlimit < 8.'
  echo ''
  echo 'Command line'
  echo ' standard mri_permute command line with standard defaults'
  echo ''
  echo 'Required utilities/scripts'
  echo ' mri_permute'
# echo ' errmsg.csh'
# echo ' mri.datfile.csh mri.sizeof.csh'
# echo ' mri_permute mri_printfield'
  echo ''
  echo 'Notes'
  echo ' Treating the following  special cases is perhaps in the'
  echo ' spirit of this  wrapper,  but it is quite tricky due to'
  echo ' lack of  a utility  that will allow  changing the value'
  echo ' in a key-value pair in a .mri file:'
  echo '  (a) new order same as the existing dimensions order'
  echo '  (b) size-1 chunks'
# echo ''
# echo 'Defaults'
# echo " verbosity: ${verbosity} (maximum ${verbmax})"
# echo " temporary files prefix: ${tmp}"
  exit 0;
 endif

 set pos = `echo ${argv} | awk '{print index($0,"-m")}'`
 if ( ${pos} != 0 ) then
  set mem    = ( `echo ${argv} | awk '{print substr($0,'${pos}')}' | awk '{print $1" "$2}'` )
  set memopt = `echo ${mem[1]} | sed 's/\-//'`
  shift mem
  set memnew = ${mem}
  if ( ${mem} < 8 ) set memnew = 8
  set argv = ( `echo ${argv} | sed 's/\-'${memopt}' '${mem}'/-'${memopt}' '${memnew}'/'` )
 else
 endif

 mri_permute ${argv}

 exit ${status}

# ------------------------------------------- incomplete stuff
#
# standard mri_permute defaults for input file, chunk name, order
#
 set input  = 'input.mri'
 set chunk  = 'images'
 set order  = 'vtxyz'

 set pos = `echo ${argv} | awk '{print index($0,"-i")}'`
 if ( ${pos} != 0 ) set input = `echo ${argv} | awk '{print substr($0,'${pos}')}' | awk '{print $2}' | sed 's/\.mri$//'`

 # echo pos $pos input $input

 set pos = `echo ${argv} | awk '{print index($0,"-c")}'`
 if ( ${pos} != 0 ) set chunk = `echo ${argv} | awk '{print substr($0,'${pos}')}' | awk '{print $2}'`

 # echo pos $pos chunk $chunk

 set pos = `echo ${argv} | awk '{print index($0,"-o")}'`
 if ( ${pos} != 0 ) set order = `echo ${argv} | awk '{print substr($0,'${pos}')}' | awk '{print $2}'`

 # echo pos $pos order $order

# chunk order
#
 set chunkorder = `mri_printfield -input ${input} -field ${chunk}.dimensions`

 errmsg.csh 1 ${myname} 4 "failed command" ${status} "mri_printfield -input ${input} -field ${chunk}.dimensions"
 if ( ${status} ) exit ${status}

# chunk size
#
#set chunksize = `mri_printfield -input ${input} -field ${chunk}.size`

#errmsg.csh 1 ${myname} 2 "failed command" ${status} "mri_printfield -input ${input} -field ${chunk}.size"
#if ( ${status} ) exit ${status}

#set chunktype = `mri_printfield -input ${input} -field ${chunk}.datatype`

#errmsg.csh 1 ${myname} 3 "failed command" ${status} "mri_printfield -input ${input} -field ${chunk}.datatype"
#if ( ${status} ) exit ${status}

#@ chunksize /= `mri.sizeof.csh ${chunktype}`

# bypass special cases
#
 if ( ( ${chunkorder} == ${order} ) || ( ${chunksize} == 1 ) ) then
  set output = 'permute'
  set pos = `echo ${argv} | awk '{print index($0,"-h")}'`
  if ( ${pos} != 0 ) set output = `echo ${argv} | awk '{print substr($0,'${pos}')}' | awk '{print $2}' | sed 's/\.mri$//'`

  # echo pos $pos output $output

  set outdat = '.dat'
  set pos = `echo ${argv} | awk '{print index($0,"-d")}'`
  if ( ${pos} != 0 ) set outdat = `echo ${argv} | awk '{print substr($0,'${pos}')}' | awk '{print $2}'`

  # echo pos $pos outdat $outdat

  if ( `echo ${outdat} | awk '{print match($0,"^\.")match($0,"^\.\/")match($0,"^\.\.\.\/")}'` == 100 ) then
   set outdatfile = ${output}'.dat'
  else
   set outdatfile = ${outdat}
  endif

  # echo outdatfile $outdatfile

  set indatfile = `mri.datfile.csh -V -infile ${input} -chunk ${chunk}`

  errmsg.csh 1 ${myname} 5 "failed command" ${status} "mri.datfile.csh -V -infile ${input} -chunk ${chunk}`"
  if ( ${status} ) exit ${status}

  # echo indatfile $indatfile

  cp ${indatfile} ${outdatfile}

  # ATTN this is tricky. If the mri file contains binary stuff,
  # don't know how to replace the .dimensions or .file fields.
  # Also, need to check that the new dimensions are a permutation
  # of the chunk dimensions.
  #
  if ( ${chunkorder} == ${order} ) then
   cp ${input}.mri ${output}.mri
  else
  endif
 else
  mri_permute ${argv}
 endif
