#!/bin/tcsh -f

# ---------------------------------------------------------------------------
#
# try -help for details
#
# ---------------------------------------------------------------------------
# $Id$
# ---------------------------------------------------------------------------

# defaults
#
 set myname = ${0:t}

# misc
#
 set type = ''

# command line args
#
 if ( ${#argv} == 0 ) set argv = -help

 while ( ${#argv} > 0 )
  switch ( ${argv[1]} )
   case "-h":
   case "-help":
    echo ${myname}
    echo ' od names for standard libmri data types'
    echo ' uint8, int16, int32,  float32,  float64'
    echo ' ("c" for everything else).'
    echo ''
    echo 'Command line'
    echo " ${myname} [-h|-help]"
    echo " ${myname} mritype"
#   echo ''
#   echo 'Defaults'
#   echo " verbosity: ${verbosity} (maximum ${verbmax})"
#   echo " temporary files prefix: ${tmp}"
    exit 0;

   case "-q":
   case "-quiet":
    shift; breaksw;

   case "-v":
   case "-verbosity":
    shift; shift; breaksw;

   case "-V":
   case "-verbose":
    shift; breaksw;

   default:
    set type = ${argv[1]}; shift; breaksw;
  endsw
 end

 switch ( ${type} )
  case 'uint8':
   echo 'u1'; exit 0;
  case 'int16':
   echo 'd2'; exit 0;
  case 'int32':
   echo 'd4'; exit 0;
  case 'float32':
   echo 'f4'; exit 0;
  case 'float64':
   echo 'f8'; exit 0;
  default:
   echo 'UNKNOWN'; exit 0;
 endsw
