#!/bin/tcsh -f

# ---------------------------------------------------------------------------
#
# try -help for details
#
# ---------------------------------------------------------------------------
# $Id$
# ---------------------------------------------------------------------------

# defaults
#
 set myname = ${0:t}

# temporary files prefix
#
 mkdir -p /tmp/${user}
 set tmpdir = /tmp/${user}/
 set tmp    = ${tmpdir}`echo ${myname} | sed 's/\.csh$//'`.`date '+%m%d%T' | sed 's/://g'`

# misc
#
 set infile    = ''
 set align     = 'l'
 set separator = ''

# command line args
#
 if ( ${#argv} == 0 ) set argv = -help

 while ( ${#argv} > 0 )
  switch ( ${argv[1]} )
   case "-h":
   case "-help":
    echo "${myname}"
    echo " assuming that the input file is in a tabular format, with"
    echo " with columns separated by spaces,  this pretty-prints it."
    echo " default justification for all columns is left;  right can"
    echo " be specified through the second argument. blank lines OK."
    echo " Use '-' for file when using standard input/pipe."
    echo ""
    echo "usage"
    echo " ${myname} [-align|-a l|r] [-separator|-s string] [file|-]"
#   echo ''
#   echo 'Defaults'
#   echo " verbosity: ${verbosity} (maximum ${verbmax})"
#   echo " temporary files prefix: ${tmp}"
    exit 0

   case "-a":
   case "-align":
    set align = ${argv[2]};
    if ( ( ${align} != 'l' ) && ( ${align} != 'r' ) ) set align = l
    shift; shift; breaksw;

   case "-s":
   case "-separator":
    set separator = "${argv[2]}"; shift; shift; breaksw;

   default:
    set infile = ${argv[1]}; shift; breaksw;
  endsw
 end

# file to be pretty-printed
#
 if ( "${infile}" == '' ) set infile = '-'

 if ( "${infile}" == '-' ) then
  cat ${infile} > ${tmp}
  set infile = ${tmp}
 endif

 # echo infile \"${infile}\"

# alignment
#
 if ( ${align} == 'r' ) set align = ''
 if ( ${align} == 'l' ) set align = '-'

 # echo align \"${align}\"

# separator
#
 if ( ${separator} != '' ) set separator = "-F'${separator}'"

 # echo separator \"${separator}\"

# maximum number of columns across all lines
#
 alias myawk "awk ${separator} '"'{if(NF>x)x=NF}END{print x}'"'"
 # which myawk
 set ncols = `myawk ${infile}`

 # echo ncols \"$ncols\"

# columwise widths
#
 set format = ''
 set clist  = ''

 set c = 1
 while ( ${c} <= ${ncols} )
  alias myawk "awk ${separator} '"'{l=length($'${c}');if(l>x)x=l}END{print x}'"'"
  # which myawk
  set width = `myawk ${infile}`
  set format = ( ${format} '%'${align}${width}'s' )
  set clist = ${clist}',$'${c}
  # echo c \"${c}\" width \"$width\" format \"$format\" clist \"$clist\"
  # echo awk ${separator} '{l=length($'${c}');if(l>x)x=l}END{print x}' ${infile}
  @ c += 1
 end

 # echo clist  \"$clist\"
 # echo format \"$format\"

# pretty-print alias
#
 alias myawk "awk "${separator}" '{printf "'"'${format}'\n"'${clist}"}'"

 # which myawk

# pretty-print
#
 myawk ${infile}

# cleanup
#
 rm -f ${tmp}* >& /dev/null; exit 0
