#!/bin/tcsh -f

# ATTN Incomplete/Ill-conceived.

exit -911

# defaults
#
 set myname = ${0:t}

# temporary files
#
 set tmpdir = /tmp/${user}/
 mkdir -p ${tmpdir}

# command line args
#
 set packages = ()

 if ( ${#argv} == 0 ) set argv = -help

 while ( ${#argv} > 0 )
  switch ( ${argv[1]} )
   case "-h":
   case "-help":
    echo ${myname}
    echo ' Create a tar.gz archive of package + dependencies'
    echo ''
    echo 'Command line'
    echo ' [-h|-help]'
    echo ''
    echo ' [-m|-moveto destination]'
    echo ' package dependency1 dependency2 ...'
    echo ''
    echo 'Termination status codes'
    echo ' 0: normal termination'
    echo ' 1: abnormal termination, except'
    echo ' 2: no package/dependency specified'
    echo ''
#   echo 'Temporary files prefix'
#   echo " ${tmp}"
    echo ''
    echo 'Notes'
    echo ' 1 Name of the archive created is'
    echo '   (destination)(package).and.dependencies.tar.gz.'
    echo ' 2 still under construction; may need debugging.'
    echo ' 3 Symbolic links may cause problems.'
    exit 0;

   case "-m":
   case "-moveto":
    set destination = ${argv[2]}
    shift; shift; breaksw;

   default:
    if ( !( ${?this} ) ) then
     set this = ${argv[1]}
    else
     set packages = ( ${packages} ${argv[1]} )
    endif
    shift
  endsw
 end

 if ( !( ${?this} ) ) then
  echo 'no package/dependencies specified'
  exit 2
 endif

# output archive
#
 set targz = ${tmpdir}/${this:t}.and.dependencies.tar

# add packages to archive one at a time
# (symbolic links may cause problems)
#
 pushd ${this:h}/../
 tar -cvf ${targz} ${this:t}/*
 popd

 foreach p ( ${packages} )
  pushd ${p:h}/../
  tar -uvf ${targz} ${p:t}/*
  popd
 end

# gzip
#
 gzip -9f ${targz}

# move to final destination
#
 mv -f ${targz}.gz ${destination}
