 echo '# Function from Venables & Ripley,'                               > ${oprefix}.S
 echo '# Modern Applied Statistics with S-Plus, 3rd ed.'                >> ${oprefix}.S
 echo '#'                                                               >> ${oprefix}.S
 echo 'nclass.FD <- function( x )'                                      >> ${oprefix}.S
 echo ' {'                                                              >> ${oprefix}.S
 echo '  r <- quantile( x, c( 0.25, 0.75 ) )'                           >> ${oprefix}.S
 echo '  names( r ) <- NULL # to avoid the label 75%'                   >> ${oprefix}.S
 echo '  h <- 2 * ( r[2] - r[1] ) * length( x )^{-1/3}'                 >> ${oprefix}.S
 echo '  ceiling( diff( range( x ) / h ) )'                             >> ${oprefix}.S
 echo ' }'                                                              >> ${oprefix}.S
 echo ''                                                                >> ${oprefix}.S
 echo '# Spectral density analysis functions from' >> ${oprefix}.S
 echo '# the book' >> ${oprefix}.S
 echo '# by Sam Efromovich; http://math.unm.edu/~efrom/book1/' >> ${oprefix}.S
 echo '#' >> ${oprefix}.S
 echo 'ab.vec <- function( f = NA )' >> ${oprefix}.S
 echo ' {' >> ${oprefix}.S
 echo '  n   <- length( f ) + 1.' >> ${oprefix}.S
 echo '  f   <- c( f, 0. )' >> ${oprefix}.S
 echo '  vec <- c( 0., 0. )' >> ${oprefix}.S
 echo '' >> ${oprefix}.S
 echo '  if ( all( f > 0. ) )' >> ${oprefix}.S
 echo '   {' >> ${oprefix}.S
 echo '    vec <- c( vec, 1., n )' >> ${oprefix}.S
 echo '   }' >> ${oprefix}.S
 echo '  else' >> ${oprefix}.S
 echo '   {' >> ${oprefix}.S
 echo '    seq.pos <- ( 1.:n )[f > 0.]' >> ${oprefix}.S
 echo '    seq.neg <- ( 1.:n )[f <= 0.]' >> ${oprefix}.S
 echo '    seq.neg <- seq.neg[seq.neg > 1.]' >> ${oprefix}.S
 echo '    a <- 1.' >> ${oprefix}.S
 echo '    while ( length( seq.pos ) * length( seq.neg ) > 0. )' >> ${oprefix}.S
 echo '     {' >> ${oprefix}.S
 echo '      if ( f[a + 1.] > 0. )' >> ${oprefix}.S
 echo '       {' >> ${oprefix}.S
 echo '        b <- min( seq.neg ) - 1.' >> ${oprefix}.S
 echo '       }' >> ${oprefix}.S
 echo '      else' >> ${oprefix}.S
 echo '       {' >> ${oprefix}.S
 echo '        a <- min( seq.pos )' >> ${oprefix}.S
 echo '        seq.neg <- seq.neg[seq.neg > a]' >> ${oprefix}.S
 echo '        b <- min( seq.neg ) - 1.' >> ${oprefix}.S
 echo '       }' >> ${oprefix}.S
 echo '      vec <- c( vec, a, b )' >> ${oprefix}.S
 echo '      seq.pos <- seq.pos[seq.pos > b]' >> ${oprefix}.S
 echo '      seq.neg <- seq.neg[seq.neg > b]' >> ${oprefix}.S
 echo '      a <- b' >> ${oprefix}.S
 echo '     }' >> ${oprefix}.S
 echo '   }' >> ${oprefix}.S
 echo '' >> ${oprefix}.S
 echo '  if ( vec[length( vec )] == n )' >> ${oprefix}.S
 echo '   {' >> ${oprefix}.S
 echo '    vec[length( vec )] <- n - 1.' >> ${oprefix}.S
 echo '   }' >> ${oprefix}.S
 echo '' >> ${oprefix}.S
 echo '  vec' >> ${oprefix}.S
 echo ' }' >> ${oprefix}.S
 echo '' >> ${oprefix}.S
 echo 'rem.bump1 <- function( f = NA, AREASQ = NA, coef = 1. )' >> ${oprefix}.S
 echo ' {' >> ${oprefix}.S
 echo '  n   <- length( f )' >> ${oprefix}.S
 echo '  vec <- ab.vec( f )' >> ${oprefix}.S
 echo '' >> ${oprefix}.S
 echo '  if ( length( vec ) > 2. )' >> ${oprefix}.S
 echo '   {' >> ${oprefix}.S
 echo '    vec <- vec[ - c( 1., 2. )]' >> ${oprefix}.S
 echo '    k   <- length( vec ) / 2.' >> ${oprefix}.S
 echo '    for ( s in 1.:k )' >> ${oprefix}.S
 echo '     {' >> ${oprefix}.S
 echo '      if ( sum( ( f[vec[2. * s - 1.]:vec[2. * s]] )^2. ) / n <= coef * AREASQ )' >> ${oprefix}.S
 echo '       {' >> ${oprefix}.S
 echo '        f[vec[2. * s - 1.]:vec[2. * s]] <- 0.' >> ${oprefix}.S
 echo '       }' >> ${oprefix}.S
 echo '     }' >> ${oprefix}.S
 echo '   }' >> ${oprefix}.S
 echo '' >> ${oprefix}.S
 echo '  f' >> ${oprefix}.S
 echo ' }' >> ${oprefix}.S
 echo '' >> ${oprefix}.S
 echo 'negden <- function( f = NA, delta = 0.01, FLAGBUMP = 1., cB = 2. )' >> ${oprefix}.S
 echo ' {' >> ${oprefix}.S
 echo '  flag <- 0.' >> ${oprefix}.S
 echo '  f1   <- f' >> ${oprefix}.S
 echo '  k    <- length( f )' >> ${oprefix}.S
 echo '  AREA <- ( k/( k - 1. ) ) * mean( f ) - ( f[1.] + f[k] )/( 2. * ( k - 1. ) )' >> ${oprefix}.S
 echo '' >> ${oprefix}.S
 echo '  if ( all( f >= 0. ) )' >> ${oprefix}.S
 echo '   {' >> ${oprefix}.S
 echo '    flag <- 1.' >> ${oprefix}.S
 echo '   }' >> ${oprefix}.S
 echo '' >> ${oprefix}.S
 echo '  if ( all( f <= 2. * delta ) | ( AREA <= 2. * delta ) )' >> ${oprefix}.S
 echo '   {' >> ${oprefix}.S
 echo '    flag <- 2.' >> ${oprefix}.S
 echo '   }' >> ${oprefix}.S
 echo '' >> ${oprefix}.S
 echo '   while ( flag == 0. )' >> ${oprefix}.S
 echo '    {' >> ${oprefix}.S
 echo '     f <- f - delta' >> ${oprefix}.S
 echo '     f[f < 0.] <- 0.' >> ${oprefix}.S
 echo '     int <- ( k/( k - 1. ) ) * mean( f ) - ( f[1.] + f[k] )/( 2. * ( k - 1. ) )' >> ${oprefix}.S
 echo '     if ( int <= AREA )' >> ${oprefix}.S
 echo '      {' >> ${oprefix}.S
 echo '       if ( int > ( 10. * delta ) )' >> ${oprefix}.S
 echo '        {' >> ${oprefix}.S
 echo '         f <- f * ( AREA/int )' >> ${oprefix}.S
 echo '        }' >> ${oprefix}.S
 echo '       flag <- 1.' >> ${oprefix}.S
 echo '      }' >> ${oprefix}.S
 echo '    }' >> ${oprefix}.S
 echo '' >> ${oprefix}.S
 echo '   if ( FLAGBUMP == 1. )' >> ${oprefix}.S
 echo '    {' >> ${oprefix}.S
 echo '     AREASQ <- mean( ( f - f1 )^2. )' >> ${oprefix}.S
 echo '     f      <- rem.bump1( f = f, AREASQ = AREASQ, coef = cB )' >> ${oprefix}.S
 echo '    }' >> ${oprefix}.S
 echo '' >> ${oprefix}.S
 echo '   if ( flag == 1. )' >> ${oprefix}.S
 echo '    {' >> ${oprefix}.S
 echo '     if ( mean( f ) > ( 10. * delta ) )' >> ${oprefix}.S
 echo '      {' >> ${oprefix}.S
 echo '       f <- f * ( AREA/mean( f ) )' >> ${oprefix}.S
 echo '      }' >> ${oprefix}.S
 echo '    }' >> ${oprefix}.S
 echo '' >> ${oprefix}.S
 echo '   f[f < 0.] <- 0.' >> ${oprefix}.S
 echo '' >> ${oprefix}.S
 echo '   f' >> ${oprefix}.S
 echo ' }' >> ${oprefix}.S
 echo '' >> ${oprefix}.S
 echo 'Updiag <- function( J = 2. )' >> ${oprefix}.S
 echo ' {' >> ${oprefix}.S
 echo '  m <- matrix( 1., nrow = J, ncol = J )' >> ${oprefix}.S
 echo '  m[row( m ) > col( m )] <- 0.' >> ${oprefix}.S
 echo '  m' >> ${oprefix}.S
 echo ' }' >> ${oprefix}.S
 echo '' >> ${oprefix}.S
 echo 'estspden <- function( X   = NA, TT  = NA,  FLAGMIS = 0., knots = 100.,' >> ${oprefix}.S
 echo '                      cJ0 = 4., cJ1 = 0.5, cJM     = 6., cT    = 4., cB = 2., FLAGNEG = 1. )' >> ${oprefix}.S
 echo ' {' >> ${oprefix}.S
 echo '  n <- length( X )' >> ${oprefix}.S
 echo '  if ( FLAGMIS == 1. )' >> ${oprefix}.S
 echo '   {' >> ${oprefix}.S
 echo '    n <- sum( TT )' >> ${oprefix}.S
 echo '   }' >> ${oprefix}.S
 echo '' >> ${oprefix}.S
 echo '  JMAX   <- ceiling( cJ0 + cJ1 * logb( n + 3. ) )' >> ${oprefix}.S
 echo '  theta1 <- acf( X, lag.max = cJM * JMAX + 1., type = "covariance", plot = F )$acf[, 1., 1.]' >> ${oprefix}.S
 echo '' >> ${oprefix}.S
 echo '  if ( FLAGMIS == 1. )' >> ${oprefix}.S
 echo '   {' >> ${oprefix}.S
 echo '    cc     <- acf( TT, cJM * JMAX + 1., type = "covariance", plot = F )$acf[, 1., 1.] + mean( TT )^2.' >> ${oprefix}.S
 echo '    theta1 <- ( theta1 + mean( X )^2. )/cc' >> ${oprefix}.S
 echo '   }' >> ${oprefix}.S
 echo '' >> ${oprefix}.S
 echo '  d <- 2. * sum( theta1[1.:JMAX]^2. ) - theta1[1.]^2.' >> ${oprefix}.S
 echo '  thetasq1 <- theta1^2. - d/n' >> ${oprefix}.S
 echo '  thetasq1[thetasq1 < 0.] <- 0.' >> ${oprefix}.S
 echo '  theta <- theta1[1.:JMAX]' >> ${oprefix}.S
 echo '  thetasq <- thetasq1[1.:JMAX]' >> ${oprefix}.S
 echo '  error <- matrix( d/n - thetasq, nrow = 1. ) %*% Updiag( JMAX )' >> ${oprefix}.S
 echo '  J <- order( error )[1.]' >> ${oprefix}.S
 echo '  theta <- theta[1.:J]' >> ${oprefix}.S
 echo '  thetasq <- thetasq[1.:J]' >> ${oprefix}.S
 echo '  arg <- outer( seq( 0., pi, len = knots ), ( 0.:( cJM * JMAX ) ) )' >> ${oprefix}.S
 echo '  bas <- cos( arg )/pi' >> ${oprefix}.S
 echo '  theta <- ( theta * thetasq )/( thetasq + ( d/n ) )' >> ${oprefix}.S
 echo '  theta[1.] <- theta[1.]/2.' >> ${oprefix}.S
 echo '' >> ${oprefix}.S
 echo '  if ( cJM <= 1. )' >> ${oprefix}.S
 echo '   {' >> ${oprefix}.S
 echo '    if ( JMAX > J )' >> ${oprefix}.S
 echo '     {' >> ${oprefix}.S
 echo '      theta <- c( theta, rep( 0., JMAX - J + 1. ) )' >> ${oprefix}.S
 echo '     }' >> ${oprefix}.S
 echo '   }' >> ${oprefix}.S
 echo '' >> ${oprefix}.S
 echo '  if ( cJM > 1. )' >> ${oprefix}.S
 echo '   {' >> ${oprefix}.S
 echo '    rest.theta <- theta1[( J + 1. ):( cJM * JMAX + 1. )]' >> ${oprefix}.S
 echo '    rest.theta[rest.theta^2. < ( cT * d * logb( n + 3. ) )/n] <- 0.' >> ${oprefix}.S
 echo '    theta <- c( theta, rest.theta )' >> ${oprefix}.S
 echo '   }' >> ${oprefix}.S
 echo '' >> ${oprefix}.S
 echo '  f <- bas %*% theta' >> ${oprefix}.S
 echo '' >> ${oprefix}.S
 echo '  if ( FLAGNEG == 1. )' >> ${oprefix}.S
 echo '   {' >> ${oprefix}.S
 echo '    f <- negden( f, FLAGBUMP = 1., cB = cB )' >> ${oprefix}.S
 echo '   }' >> ${oprefix}.S
 echo '  else' >> ${oprefix}.S
 echo '   {' >> ${oprefix}.S
 echo '    f[f < 0.] <- 0.' >> ${oprefix}.S
 echo '   }' >> ${oprefix}.S
 echo '' >> ${oprefix}.S
 echo '  f' >> ${oprefix}.S
 echo ' }' >> ${oprefix}.S
 echo ''                                                                >> ${oprefix}.S
 echo 'residuals <- scan( "'${oprefix}.resid.txt'" );'                  >> ${oprefix}.S
 echo ''                                                                >> ${oprefix}.S
 echo 'postscript( ); pscript( onefile = F, horizo = F, print = F );'   >> ${oprefix}.S
 echo 'acf( residuals ); dev.off( );'                                   >> ${oprefix}.S
 echo ''                                                                >> ${oprefix}.S
 echo 'postscript( ); pscript( onefile = F, horizo = F, print = F );'   >> ${oprefix}.S
 echo 'hist( residuals, nclass = nclass.FD( residuals ) ); dev.off( );' >> ${oprefix}.S
 echo ''                                                                >> ${oprefix}.S
 echo 'postscript( ); pscript( onefile = F, horizo = F, print = F );'   >> ${oprefix}.S
 echo 'qqnorm( residuals ); qqline( residuals ); dev.off( );'           >> ${oprefix}.S
 echo ''                                                                >> ${oprefix}.S
 echo 'sp <- estspden( residuals );'                                    >> ${oprefix}.S
 echo 'f  <- seq( 0.0, 0.5, length = length( sp ) );'                   >> ${oprefix}.S
 echo ''                                                                >> ${oprefix}.S
 echo 'postscript( ); pscript( onefile = F, horizo = F, print = F );'   >> ${oprefix}.S
 echo "plot( f, sp, type = 'l', ylab = 'Spectral Density' );"           >> ${oprefix}.S
 echo 'dev.off( );'                                                     >> ${oprefix}.S

 Splus < ${oprefix}.S >& ${oprefix}.S.out

 if ( ( ${status} != 0 ) || ( `grep -ci problem ${oprefix}.S.out` != 0 ) ) then
  if ( ${verbosity} > 0 ) then
   echo -n ${myname}':' failed command \"
   echo 'Splus < '${oprefix}'.S >& '${oprefix}'.S.out'
   echo See ${oprefix}.S.out for possible details.
  endif

  set errstatus = 30

  set rhistplot = ${tmp}.sad.eps
  set rqqplot   = ${tmp}.sad.eps
  set racfnplot = ${tmp}.sad.eps
  set rsdplot   = ${tmp}.sad.eps
 else
  set rfiles = ( `cat ${oprefix}.S.out | grep "^Generated postscript file" | awk '{print $4}' | sed -e 's/^"//' -e 's/"\.$//'` )

  mv ${rfiles[1]} ${racfnplot}
  mv ${rfiles[2]} ${rhistplot}
  mv ${rfiles[3]} ${rqqplot}
  mv ${rfiles[4]} ${rsdplot}

  unset rfiles
 endif

# if any of the plots could not be generated,
# substitute a sad face for that.
#
 if ( ${errstatus} != 0 ) then
  echo 'set nokey; set noborder; set noxtics; set noytics;'              > ${tmp}.gpt
  echo 'set samples 49; set xrange [-1:1]; set yrange [-1:1];'          >> ${tmp}.gpt
  echo "set terminal postscript eps; set output '"${tmp}".sad.eps';"    >> ${tmp}.gpt
  echo 'a=9.0/4.0;b=5.0/16.0;'                                          >> ${tmp}.gpt
  echo 'pl sqrt(1.0-x*x) w l lt 1 lw 3, -sqrt(1.0-x*x) w l lt 1 lw 3,\' >> ${tmp}.gpt
  echo '   -0.5*(1.5-sqrt(a-4*(b+x*x))) w l lt 1 lw 3,\'                >> ${tmp}.gpt
  echo '    0.5*(0.5+sqrt(0.25-4.0*(x*x+x+0.25))) w l lt 1 lw 3,\'      >> ${tmp}.gpt
  echo '    0.5*(0.5-sqrt(0.25-4.0*(x*x+x+0.25))) w l lt 1 lw 3,\'      >> ${tmp}.gpt
  echo '    0.5*(0.5+sqrt(0.25-4.0*(x*x-x+0.25))) w l lt 1 lw 3,\'      >> ${tmp}.gpt
  echo '    0.5*(0.5-sqrt(0.25-4.0*(x*x-x+0.25))) w l lt 1 lw 3'        >> ${tmp}.gpt

  set msg = `gnuplot ${tmp}.gpt`                          # ATTN this shouldn't fail!

  if ( ${status} != 0 ) then
   if ( ${verbosity} > 0 ) then
    echo ${msg}
    echo -n ${myname}':' failed command \"
    echo gnuplot ${tmp}.gpt\"
   endif
   exit 2
  endif
 endif
