/* ----------------------------------------------------------------------------
 *
 * class TCreader
 *   implementation
 *
 * ----------------------------------------------------------------------------
 * $Id$
 * ---------------------------------------------------------------------------- */

#include <timecourse.handlers/TCreader>

// ------------------------------------------------------------- construct/reinit
// ------------------------------------------------------------------------------

TCreader::TCreader( )
 : TChandler( ), my_timeCourse( )
 {
 }

TCreader::~TCreader( )
 {
 }

TCreader::TCreader( const TCreader& another )
 : TChandler( another ), my_timeCourse( another.my_timeCourse )
 {
 }

TCreader::TCreader( const TChandler& another )
 : TChandler( another ), my_timeCourse( )
 {
 }

TCreader::TCreader( const TCrw& another )
 : TChandler( another ),
   my_timeCourse( another.timeCourse( ) ) // ATTN this resets another.anyMove( )
 {
 }

TCreader&
TCreader::operator=( const TCreader& rhs )
 {
  if ( this == &rhs ) return *this;

  TChandler::operator=( rhs );

  my_timeCourse.resize( rhs.my_timeCourse.size( ) );
  my_timeCourse = rhs.my_timeCourse;
                                          //
                                          // ATTN this will reset rhs.anyMove( )

  return *this;
 }

TCreader&
TCreader::operator=( const TChandler& rhs )
 {
  TChandler::operator=( rhs );
  my_timeCourse.resize( 0 );
  return *this;
 }

TCreader&
TCreader::operator=( const TCrw& rhs )
 {
  TChandler::operator=( rhs );

  my_timeCourse.resize( rhs.timeCourse( ).size( ) );
  my_timeCourse = rhs.timeCourse( );

  return *this;
 }

TCreader::TCreader( const uintVector&     sizes,
                          size_t          tDimension,
                    const uintVector&     indexOrder,
                    const LocationType&   lowerBounds,
                    const vector<string>& names,
                          bool            deleteTrivial )
 : TChandler( sizes, tDimension, indexOrder, lowerBounds, names, deleteTrivial ),
   my_timeCourse( )
 {
 }

void
TCreader::reinitialize( const uintVector&     sizes,
                              size_t          tDimension,
                        const uintVector&     indexOrder,
                        const LocationType&   lowerBounds,
                        const vector<string>& names,
                              bool            deleteTrivial )
 {
  TChandler::reinitialize( sizes, tDimension, indexOrder, lowerBounds, names, deleteTrivial );
  my_timeCourse.resize( 0 );
 }
