/* ----------------------------------------------------------------------------
 *
 * class TCrw
 *   implementation
 *
 * ----------------------------------------------------------------------------
 * $Id$
 * ---------------------------------------------------------------------------- */

#include <timecourse.handlers/TCrw>

// ------------------------------------------------------------- construct/reinit
// ------------------------------------------------------------------------------

TCrw::TCrw( )
 : TChandler( ), my_timeCourse( )
 {
 }

TCrw::~TCrw( )
 {
 }

TCrw::TCrw( const TCrw& another )
 : TChandler( another ), my_timeCourse( another.my_timeCourse )
 {
 }

TCrw&
TCrw::operator=( const TCrw& rhs )
 {
  if ( this == &rhs ) return *this;

  TChandler::operator=( rhs );

  my_timeCourse.resize( rhs.my_timeCourse.size( ) );
  my_timeCourse = rhs.my_timeCourse;

  return *this;
 }

TCrw::TCrw( const uintVector&     sizes,
                  size_t          tDimension,
            const uintVector&     indexOrder,
            const LocationType&   lowerBounds,
            const vector<string>& names,
                  bool            deleteTrivial )
 : TChandler( sizes, tDimension, indexOrder, lowerBounds, names, deleteTrivial ),
   my_timeCourse( )
 {
 }

void
TCrw::reinitialize( const uintVector&     sizes,
                          size_t          tDimension,
                    const uintVector&     indexOrder,
                    const LocationType&   lowerBounds,
                    const vector<string>& names,
                          bool            deleteTrivial )
 {
  TChandler::reinitialize( sizes, tDimension, indexOrder, lowerBounds, names, deleteTrivial );
  my_timeCourse.resize( 0 );
 }
