/* ----------------------------------------------------------------------------
 *
 * class TCwriter
 *   implementation
 *
 * ----------------------------------------------------------------------------
 * $Id$
 * ---------------------------------------------------------------------------- */

#include <timecourse.handlers/TCwriter>

// ------------------------------------------------------------- construct/reinit
// ------------------------------------------------------------------------------

TCwriter::TCwriter( )
 : TChandler( )
 {
 }

TCwriter::~TCwriter( )
 {
 }

TCwriter::TCwriter( const TCwriter& another )
 : TChandler( another )
 {
 }

TCwriter::TCwriter( const TChandler& another )
 : TChandler( another )
 {
 }

TCwriter::TCwriter( const TCrw& another )
 : TChandler( another )
 {
 }

TCwriter&
TCwriter::operator=( const TCwriter& rhs )
 {
  if ( this == &rhs ) return *this;
  TChandler::operator=( rhs );
  return *this;
 }

TCwriter&
TCwriter::operator=( const TChandler& rhs )
 {
  TChandler::operator=( rhs );
  return *this;
 }

TCwriter&
TCwriter::operator=( const TCrw& rhs )
 {
  TChandler::operator=( rhs );
  return *this;
 }

TCwriter::TCwriter( const uintVector&     sizes,
                          size_t          tDimension,
                    const uintVector&     indexOrder,
                    const LocationType&   lowerBounds,
                    const vector<string>& names,
                          bool            deleteTrivial )
 : TChandler( sizes, tDimension, indexOrder, lowerBounds, names, deleteTrivial )
 {
 }

void
TCwriter::reinitialize( const uintVector&     sizes,
                              size_t          tDimension,
                        const uintVector&     indexOrder,
                        const LocationType&   lowerBounds,
                        const vector<string>& names,
                              bool            deleteTrivial )
 {
  TChandler::reinitialize( sizes, tDimension, indexOrder, lowerBounds, names, deleteTrivial );
 }
